/* channel.c generated by valac 0.30.1, the Vala compiler
 * generated from channel.vala, do not modify */

/*
 *    Copyright (C) 1999, 2000,
 *    Dirk-Jan C. Binnema <djcb@dds.nl>,
 *    Arjan Scherpenisse <acscherp@wins.uva.nl>
 *    Copyright (C) 2016 Colin Watson <cjwatson@debian.org>
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/* A channel. */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include "uuid.h"


#define TG_TYPE_CHANNEL (tg_channel_get_type ())
#define TG_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TG_TYPE_CHANNEL, TgChannel))
#define TG_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TG_TYPE_CHANNEL, TgChannelClass))
#define TG_IS_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TG_TYPE_CHANNEL))
#define TG_IS_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TG_TYPE_CHANNEL))
#define TG_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TG_TYPE_CHANNEL, TgChannelClass))

typedef struct _TgChannel TgChannel;
typedef struct _TgChannelClass TgChannelClass;
typedef struct _TgChannelPrivate TgChannelPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TgChannel {
	GObject parent_instance;
	TgChannelPrivate * priv;
};

struct _TgChannelClass {
	GObjectClass parent_class;
};

struct _TgChannelPrivate {
	GSettings* _settings;
	gchar* _uuid;
	gchar* _name;
	gchar* _description;
	gchar* _page_url;
	gchar* _subpage_url;
	gchar* _country;
};


static gpointer tg_channel_parent_class = NULL;

GType tg_channel_get_type (void) G_GNUC_CONST;
#define TG_CHANNEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TG_TYPE_CHANNEL, TgChannelPrivate))
enum  {
	TG_CHANNEL_DUMMY_PROPERTY,
	TG_CHANNEL_SETTINGS,
	TG_CHANNEL_UUID,
	TG_CHANNEL_NAME,
	TG_CHANNEL_DESCRIPTION,
	TG_CHANNEL_PAGE_URL,
	TG_CHANNEL_SUBPAGE_URL,
	TG_CHANNEL_COUNTRY
};
TgChannel* tg_channel_new (const gchar* uuid);
TgChannel* tg_channel_construct (GType object_type, const gchar* uuid);
TgChannel* tg_channel_new_with_parameters (const gchar* name, const gchar* description, const gchar* page_url, const gchar* subpage_url, const gchar* country);
TgChannel* tg_channel_construct_with_parameters (GType object_type, const gchar* name, const gchar* description, const gchar* page_url, const gchar* subpage_url, const gchar* country);
static void tg_channel_bind_settings (TgChannel* self);
const gchar* tg_channel_get_uuid (TgChannel* self);
static void tg_channel_set_settings (TgChannel* self, GSettings* value);
GSettings* tg_channel_get_settings (TgChannel* self);
static void tg_channel_set_uuid (TgChannel* self, const gchar* value);
const gchar* tg_channel_get_name (TgChannel* self);
void tg_channel_set_name (TgChannel* self, const gchar* value);
const gchar* tg_channel_get_description (TgChannel* self);
void tg_channel_set_description (TgChannel* self, const gchar* value);
const gchar* tg_channel_get_page_url (TgChannel* self);
void tg_channel_set_page_url (TgChannel* self, const gchar* value);
const gchar* tg_channel_get_subpage_url (TgChannel* self);
void tg_channel_set_subpage_url (TgChannel* self, const gchar* value);
const gchar* tg_channel_get_country (TgChannel* self);
void tg_channel_set_country (TgChannel* self, const gchar* value);
static GObject * tg_channel_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void tg_channel_finalize (GObject* obj);
static void _vala_tg_channel_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_tg_channel_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


TgChannel* tg_channel_construct (GType object_type, const gchar* uuid) {
	TgChannel * self = NULL;
	const gchar* _tmp0_ = NULL;
	_tmp0_ = uuid;
	self = (TgChannel*) g_object_new (object_type, "uuid", _tmp0_, NULL);
	return self;
}


TgChannel* tg_channel_new (const gchar* uuid) {
	return tg_channel_construct (TG_TYPE_CHANNEL, uuid);
}


TgChannel* tg_channel_construct_with_parameters (GType object_type, const gchar* name, const gchar* description, const gchar* page_url, const gchar* subpage_url, const gchar* country) {
	TgChannel * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	_tmp0_ = name;
	_tmp1_ = description;
	_tmp2_ = page_url;
	_tmp3_ = subpage_url;
	_tmp4_ = country;
	self = (TgChannel*) g_object_new (object_type, "name", _tmp0_, "description", _tmp1_, "page-url", _tmp2_, "subpage-url", _tmp3_, "country", _tmp4_, NULL);
	return self;
}


TgChannel* tg_channel_new_with_parameters (const gchar* name, const gchar* description, const gchar* page_url, const gchar* subpage_url, const gchar* country) {
	return tg_channel_construct_with_parameters (TG_TYPE_CHANNEL, name, description, page_url, subpage_url, country);
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


static void tg_channel_bind_settings (TgChannel* self) {
	gchar* path = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GSettings* _tmp3_ = NULL;
	GSettings* _tmp4_ = NULL;
	GSettings* _tmp5_ = NULL;
	GSettings* _tmp6_ = NULL;
	GSettings* _tmp7_ = NULL;
	GSettings* _tmp8_ = NULL;
	GSettings* _tmp9_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_uuid;
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = g_strconcat ("/org/gnome/telegnome/channel/", _tmp1_, "/", NULL);
	path = _tmp2_;
	_tmp3_ = g_settings_new_with_path ("org.gnome.telegnome.channel", path);
	_tmp4_ = _tmp3_;
	tg_channel_set_settings (self, _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = self->priv->_settings;
	g_settings_bind (_tmp5_, "name", (GObject*) self, "name", G_SETTINGS_BIND_DEFAULT);
	_tmp6_ = self->priv->_settings;
	g_settings_bind (_tmp6_, "description", (GObject*) self, "description", G_SETTINGS_BIND_DEFAULT);
	_tmp7_ = self->priv->_settings;
	g_settings_bind (_tmp7_, "page-url", (GObject*) self, "page_url", G_SETTINGS_BIND_DEFAULT);
	_tmp8_ = self->priv->_settings;
	g_settings_bind (_tmp8_, "subpage-url", (GObject*) self, "subpage_url", G_SETTINGS_BIND_DEFAULT);
	_tmp9_ = self->priv->_settings;
	g_settings_bind (_tmp9_, "country", (GObject*) self, "country", G_SETTINGS_BIND_DEFAULT);
	_g_free0 (path);
}


GSettings* tg_channel_get_settings (TgChannel* self) {
	GSettings* result;
	GSettings* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_settings;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void tg_channel_set_settings (TgChannel* self, GSettings* value) {
	GSettings* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_settings);
	self->priv->_settings = _tmp1_;
	g_object_notify ((GObject *) self, "settings");
}


const gchar* tg_channel_get_uuid (TgChannel* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_uuid;
	result = _tmp0_;
	return result;
}


static void tg_channel_set_uuid (TgChannel* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_uuid);
	self->priv->_uuid = _tmp1_;
	g_object_notify ((GObject *) self, "uuid");
}


const gchar* tg_channel_get_name (TgChannel* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void tg_channel_set_name (TgChannel* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
	g_object_notify ((GObject *) self, "name");
}


const gchar* tg_channel_get_description (TgChannel* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_description;
	result = _tmp0_;
	return result;
}


void tg_channel_set_description (TgChannel* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_description);
	self->priv->_description = _tmp1_;
	g_object_notify ((GObject *) self, "description");
}


const gchar* tg_channel_get_page_url (TgChannel* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_page_url;
	result = _tmp0_;
	return result;
}


void tg_channel_set_page_url (TgChannel* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_page_url);
	self->priv->_page_url = _tmp1_;
	g_object_notify ((GObject *) self, "page-url");
}


const gchar* tg_channel_get_subpage_url (TgChannel* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_subpage_url;
	result = _tmp0_;
	return result;
}


void tg_channel_set_subpage_url (TgChannel* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_subpage_url);
	self->priv->_subpage_url = _tmp1_;
	g_object_notify ((GObject *) self, "subpage-url");
}


const gchar* tg_channel_get_country (TgChannel* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_country;
	result = _tmp0_;
	return result;
}


void tg_channel_set_country (TgChannel* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_country);
	self->priv->_country = _tmp1_;
	g_object_notify ((GObject *) self, "country");
}


static GObject * tg_channel_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	TgChannel * self;
	const gchar* _tmp0_ = NULL;
	parent_class = G_OBJECT_CLASS (tg_channel_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TG_TYPE_CHANNEL, TgChannel);
	_tmp0_ = self->priv->_uuid;
	if (_tmp0_ == NULL) {
		guint8* uu = NULL;
		guint8* _tmp1_ = NULL;
		gint uu_length1 = 0;
		gint _uu_size_ = 0;
		guint8* _tmp2_ = NULL;
		gint _tmp2__length1 = 0;
		gchar* real_uuid = NULL;
		gchar* _tmp3_ = NULL;
		gint real_uuid_length1 = 0;
		gint _real_uuid_size_ = 0;
		guint8* _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		gchar* _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
		gchar* _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		_tmp1_ = g_new0 (guint8, 16);
		uu = _tmp1_;
		uu_length1 = 16;
		_uu_size_ = uu_length1;
		_tmp2_ = uu;
		_tmp2__length1 = uu_length1;
		uuid_generate (_tmp2_);
		_tmp3_ = g_new0 (gchar, 37);
		real_uuid = _tmp3_;
		real_uuid_length1 = 37;
		_real_uuid_size_ = real_uuid_length1;
		_tmp4_ = uu;
		_tmp4__length1 = uu_length1;
		_tmp5_ = real_uuid;
		_tmp5__length1 = real_uuid_length1;
		uuid_unparse (_tmp4_, _tmp5_);
		_tmp6_ = real_uuid;
		_tmp6__length1 = real_uuid_length1;
		tg_channel_set_uuid (self, (const gchar*) _tmp6_);
		real_uuid = (g_free (real_uuid), NULL);
		uu = (g_free (uu), NULL);
	}
	tg_channel_bind_settings (self);
	return obj;
}


static void tg_channel_class_init (TgChannelClass * klass) {
	tg_channel_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TgChannelPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_tg_channel_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tg_channel_set_property;
	G_OBJECT_CLASS (klass)->constructor = tg_channel_constructor;
	G_OBJECT_CLASS (klass)->finalize = tg_channel_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TG_CHANNEL_SETTINGS, g_param_spec_object ("settings", "settings", "settings", G_TYPE_SETTINGS, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TG_CHANNEL_UUID, g_param_spec_string ("uuid", "UUID", "UUID", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TG_CHANNEL_NAME, g_param_spec_string ("name", "Name", "Name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TG_CHANNEL_DESCRIPTION, g_param_spec_string ("description", "Description", "Description", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TG_CHANNEL_PAGE_URL, g_param_spec_string ("page-url", "Page URL", "Page URL", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TG_CHANNEL_SUBPAGE_URL, g_param_spec_string ("subpage-url", "Subpage URL", "Subpage URL", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TG_CHANNEL_COUNTRY, g_param_spec_string ("country", "Country", "Country", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void tg_channel_instance_init (TgChannel * self) {
	self->priv = TG_CHANNEL_GET_PRIVATE (self);
}


static void tg_channel_finalize (GObject* obj) {
	TgChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TG_TYPE_CHANNEL, TgChannel);
	_g_object_unref0 (self->priv->_settings);
	_g_free0 (self->priv->_uuid);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_description);
	_g_free0 (self->priv->_page_url);
	_g_free0 (self->priv->_subpage_url);
	_g_free0 (self->priv->_country);
	G_OBJECT_CLASS (tg_channel_parent_class)->finalize (obj);
}


GType tg_channel_get_type (void) {
	static volatile gsize tg_channel_type_id__volatile = 0;
	if (g_once_init_enter (&tg_channel_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TgChannelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tg_channel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TgChannel), 0, (GInstanceInitFunc) tg_channel_instance_init, NULL };
		GType tg_channel_type_id;
		tg_channel_type_id = g_type_register_static (G_TYPE_OBJECT, "TgChannel", &g_define_type_info, 0);
		g_once_init_leave (&tg_channel_type_id__volatile, tg_channel_type_id);
	}
	return tg_channel_type_id__volatile;
}


static void _vala_tg_channel_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TgChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TG_TYPE_CHANNEL, TgChannel);
	switch (property_id) {
		case TG_CHANNEL_SETTINGS:
		g_value_set_object (value, tg_channel_get_settings (self));
		break;
		case TG_CHANNEL_UUID:
		g_value_set_string (value, tg_channel_get_uuid (self));
		break;
		case TG_CHANNEL_NAME:
		g_value_set_string (value, tg_channel_get_name (self));
		break;
		case TG_CHANNEL_DESCRIPTION:
		g_value_set_string (value, tg_channel_get_description (self));
		break;
		case TG_CHANNEL_PAGE_URL:
		g_value_set_string (value, tg_channel_get_page_url (self));
		break;
		case TG_CHANNEL_SUBPAGE_URL:
		g_value_set_string (value, tg_channel_get_subpage_url (self));
		break;
		case TG_CHANNEL_COUNTRY:
		g_value_set_string (value, tg_channel_get_country (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_tg_channel_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TgChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TG_TYPE_CHANNEL, TgChannel);
	switch (property_id) {
		case TG_CHANNEL_SETTINGS:
		tg_channel_set_settings (self, g_value_get_object (value));
		break;
		case TG_CHANNEL_UUID:
		tg_channel_set_uuid (self, g_value_get_string (value));
		break;
		case TG_CHANNEL_NAME:
		tg_channel_set_name (self, g_value_get_string (value));
		break;
		case TG_CHANNEL_DESCRIPTION:
		tg_channel_set_description (self, g_value_get_string (value));
		break;
		case TG_CHANNEL_PAGE_URL:
		tg_channel_set_page_url (self, g_value_get_string (value));
		break;
		case TG_CHANNEL_SUBPAGE_URL:
		tg_channel_set_subpage_url (self, g_value_get_string (value));
		break;
		case TG_CHANNEL_COUNTRY:
		tg_channel_set_country (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



